/* @(#)dynamic_indexer.pl	1.6 13 Jul 1994

Since this file is only used by term_expansion/2, it should be loaded with

:- load_files(dynamic_indexer, when(compile_time),if(changed)]).

See the README in this directory to understand what it is doing.

This software is free: please copy it and/or modify it. Do with it what
you like.  It is a gift from KnowledgeWare Inc, and was written by Tom
Howland.

*/

:- module(dynamic_indexer, [dynamic_indexer_term_expansion/2]).
:- use_module(library(addportray)).
:- use_module(low).

/* I know it is discusting to use univ (=..). Please don't tell me. */

dynamic_indexer_term_expansion((:-dynamic_index(Specs)), Clauses) :-
    dite(Specs, Clauses, _).
dynamic_indexer_term_expansion((:-dynamic_volatile_index(Specs)),
			       [(:-volatile(X))|Clauses]) :-
    dite(Specs, Clauses, X).

dite(Specs, Clauses, PS) :-
    PS=NewTrueName/NewTrueArity,
    index_clauses(Specs, Clauses2, [], Head, _, Mod, _, _,
		  ClauseNumber, Body, Hash, Hash),
    Clauses1 = [(:-dynamic(PS)),
		(:-discontiguous('** indexed assert **'/1)),
		(:-discontiguous('** indexed retract **'/1)),
		(:-discontiguous('** indexed **'/1)),
		'** indexed **'(Head),
		(Head:-Hash,TrueNewHead),
		HashAssert, HashRetract | Clauses2],
    parse_index_specs(Specs, Head, Mod, Mod, ClauseNumber, Body, HAB1, HRB,
		      Refs, _, _, Dyn, _, _, _),
    tidy(HAB1,HAB),

    functor(Head, Name, Arity),
    concat_atom(['** ',Name,'/',Arity,' **'], NewTrueName),
    Head =.. [_|HeadArgs],
    append([NewTrueName, ClauseNumber], HeadArgs, X1),
    append(X1, Refs, TrueNewHeadList),
    TrueNewHead =.. TrueNewHeadList,
    functor(TrueNewHead, _, NewTrueArity),

    concat_atom(['clause count ', Name, '/', Arity], ClauseCount),
    functor(CCi,ClauseCount,1),
    arg(1, CCi, ClauseNumber),
    functor(CCf,ClauseCount,1),
    arg(1, CCf, CC),
    HashAssert=('** indexed assert **'(Head):-
	       (   retract(CCi)
	       ->  true
	       ;   ClauseNumber is 0
	       ),
	       CC is ClauseNumber+1,
	       assert(CCf),
	       HAB,
	       assert(TrueNewHead)),
    HashRetract=('** indexed retract **'(Head):-Hash,
		retract(TrueNewHead),HRB),
    append(Dyn, Clauses1, Clauses).

:- initialization
    add_linking_clause(dynamic_indexer_term_expansion, term_expansion, 2),
    op(1150, fx, dynamic_index).
